#include "criterion.h"

/** Cristal **/

cristal_greather_equal::cristal_greather_equal(unsigned int threshold) {
    this->threshold = threshold;
}

bool cristal_greather_equal::check(struct unit * unit) {
    return(unit->cristal->value >= this->threshold);
}

cristal_less_equal::cristal_less_equal(unsigned int threshold) {
    this->threshold = threshold;
}

bool cristal_less_equal::check(struct unit * unit) {
    return(unit->cristal->value <= this->threshold);
}

/** Power Gem **/

powergem_greather_equal::powergem_greather_equal(unsigned int threshold) {
    this->threshold = threshold;
}

bool powergem_greather_equal::check(struct unit * unit) {
    return(unit->powergem->value >= this->threshold);
}

powergem_less_equal::powergem_less_equal(unsigned int threshold) {
    this->threshold = threshold;
}

bool powergem_less_equal::check(struct unit * unit) {
    return(unit->powergem->value <= this->threshold);
}

/** Energy **/

energy_greather_equal::energy_greather_equal(unsigned int threshold) {
    this->threshold = threshold;
}

bool energy_greather_equal::check(struct unit * unit) {
    return(unit->energy->value >= this->threshold);
}

energy_less_equal::energy_less_equal(unsigned int threshold) {
    this->threshold = threshold;
}

bool energy_less_equal::check(struct unit * unit) {
    return(unit->energy->value <= this->threshold);
}

/** Model **/

model_is::model_is(struct model * model) {
    this->model = model;
}

bool model_is::check(struct unit * unit) {
    return(unit->model == this->model);
}

model_is_not::model_is_not(struct model * model) {
    this->model = model;
}

bool model_is_not::check(struct unit * unit) {
    return(unit->model != this->model);
}
