#include "event.h"

event::event(bool repeat) {
    this->repeat = repeat;
    this->done = false;
}

/*
event::~event() {
    for(struct criterion * it : this->criteria)
        delete(it);
    for(struct action * it : this->actions)
        delete(it);
}
*/

void event::check_and_trigger(struct unit * unit) {
    if(this->repeat || !this->done) {
        bool ok_trigger = true;
        for(struct criterion * it : this->criteria) {
            if(it->check(unit)) {
                    // carry on.
            } else {
                ok_trigger = false;
                break;
            }
        }
        if(ok_trigger) {
            this->trigger();
        }
    }
}

void event::trigger() {
    for(struct action * it : this->actions) {
        it->trigger();
    }
    this->done = true;
}
