#ifndef CONSOLE_H
#define CONSOLE_H

#include <SDL2/SDL_ttf.h>
#include <string>

struct console {
    TTF_Font * font;
    SDL_Texture * texture;
    SDL_Rect dst;
    SDL_Color color;

    console(std::string filename);
    ~console();
    void set(SDL_Renderer * renderer, std::string text);
    void draw(SDL_Renderer * renderer);
};

#endif // CONSOLE_H
