#ifndef GAUGE_H
#define GAUGE_H

#include "sprite.h"
#include "unit.h"

struct gauge {
    unsigned int value;
    unsigned int maximum;
    gauge(unsigned int maximum);
    bool is_full();
    bool is_empty();
    unsigned int free_space();
    void increase(unsigned int value);
    void decrease(unsigned int value);
    void gather(struct gauge * gauge);
    void draw_top(SDL_Renderer * renderer, struct unit * unit, struct sprite * sprite, unsigned int shift);
    void draw_bot(SDL_Renderer * renderer, struct unit * unit, struct sprite * sprite, unsigned int shift);
};

#endif // GAUGE_H
