#ifndef MODEL_H
#define MODEL_H

#include "sprite.h"

#include <string>

struct model {
    model(std::string name, std::string sprite_filename, SDL_Renderer * renderer);
    // ~model(); // XXX
    // load_from_file(std::string filename);
    std::string name;
    struct sprite sprite;
    unsigned int cristal_cost;
    unsigned int energy_cost;
    bool collect_energy;
    bool collect_cristal;
    bool collect_powergem;
    bool give_energy;
    bool give_cristal;
    bool give_powergem;
    float speed;
    unsigned int drill_power;
    unsigned int max_energy;
    unsigned int max_cristal;
    unsigned int max_powergem;
    unsigned int generate_energy;
    struct model * autobuild;
};

#endif // MODEL_H
